/**
* Library for HC SR04 ultrasonic sensor.
* Original code from http://www.instructables.com/id/Non-blocking-Ultrasonic-Sensor-for-Arduino/
*/

#ifndef HC_SR04_H
#define HC_SR04_H

#include <Arduino.h>

#define CM true
#define INCH false

#define DURATION_TO_CM 58
#define DURATION_TO_INCH 148

class HC_SR04 {
  public:
    HC_SR04(int trigger, int echo);
    
    void begin();
    void start();
    bool isFinished(){ return _finished; }
    unsigned int getRange(bool units=CM);
    unsigned int getRange(unsigned int duration, bool unit=CM);
    unsigned int getDuration();
    static HC_SR04* instance(){ return _instance; }
    
  private:
    static void _echo_isr();
    
    int _trigger, _echo, _int;
    volatile unsigned long _start, _end;
    volatile bool _finished;
    static HC_SR04* _instance;
};

#endif
